<%-- $Id: edit_bioplate.jsp 6321 2013-09-11 10:31:27Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.BIOPLATE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioPlate bioplate = null;
	Date eventDate = null;
	
	boolean readCurrentPlateGeometry = true;
	PlateGeometry currentPlateGeometry = null;
	boolean readCurrentBioPlateType = true;
	BioPlateType currentBioPlateType = null;
	ItemSubtype currentStorageType = null;
	
	boolean readCurrentFreezer = true;
	Hardware currentFreezer = null;
	
	if (itemId == 0)
	{
		title = "Create bioplate";
		cc.removeObject("item");

		int plateGeometryId = Values.getInt(request.getParameter("plategeometry_id"));
		if (plateGeometryId != 0)
		{
			currentPlateGeometry = PlateGeometry.getById(dc, plateGeometryId);
		}
		else if (cc.getPropertyFilter("plateType.name") != null)
		{
			currentPlateGeometry = Base.getFirstMatching(dc, PlateGeometry.getQuery(), "name", cc.getPropertyFilter("plateGeometry.name"));
		}
		int bioPlateTypeId = Values.getInt(request.getParameter("bioplatetype_id"));
		if (bioPlateTypeId != 0)
		{
			currentBioPlateType = BioPlateType.getById(dc, bioPlateTypeId);
		}
		else if (cc.getPropertyFilter("bioPlateType.name") != null)
		{
			currentBioPlateType = Base.getFirstMatching(dc, BioPlateType.getQuery(), "name", cc.getPropertyFilter("bioPlateType.name"));
			if (currentBioPlateType != null)
			{
				currentStorageType = currentBioPlateType.getStorageType();
			}
		}
		
		int freezerId = Values.getInt(request.getParameter("freezer_id"));
		if (freezerId != 0)
		{
			currentFreezer = Hardware.getById(dc, freezerId);
		}
		eventDate = (Date)cc.getPropertyObject("eventDate");
	}
	else
	{
		bioplate = BioPlate.getById(dc, itemId);
		bioplate.checkPermission(Permission.WRITE);
		cc.setObject("item", bioplate);
		title = "Edit bioplate -- " + HTML.encodeTags(bioplate.getName());
		eventDate = bioplate.getEventDate();
		try
		{
			currentPlateGeometry = bioplate.getPlateGeometry();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPlateGeometry = false;
		}
		try
		{
			currentBioPlateType = bioplate.getBioPlateType();
			currentStorageType = currentBioPlateType.getStorageType();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioPlateType = false;
		}
		try
		{
			currentFreezer = bioplate.getFreezer();			
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFreezer = false;
		}
	}
	
	// Load default items
	int activeProjectId = sc.getActiveProjectId();
	List<Hardware> defaultFreezers = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		if (currentStorageType == null) currentStorageType = ItemSubtype.getById(dc, SystemItems.getId(Hardware.FREEZER));
		defaultFreezers = (List<Hardware>)activeProject.findDefaultItems(dc, currentStorageType, false);
	}
	
	// Load recently used items
	List<Hardware> recentFreezers = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, currentStorageType);
	List<PlateGeometry> recentPlateGeometry = (List<PlateGeometry>)cc.getRecent(dc, Item.PLATEGEOMETRY);
	List<BioPlateType> recentBioPlateType = (List<BioPlateType>)cc.getRecent(dc, Item.BIOPLATETYPE);
	
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioplate);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,subtypes.js,~bioplates.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>

		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioplate">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=bioplate != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Plate" helpid="bioplate.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=bioplate == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(bioplate == null ? Values.getString(cc.getPropertyValue("name"), "New bioplate") : bioplate.getName())%>" 
					maxlength="<%=BioPlate.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Bioplate type</th>
				<td>
					<%
					if (bioplate != null)
					{
						%>
						<%=Base.getEncodedName(currentBioPlateType, !readCurrentBioPlateType)%>
						<%
					}
					else
					{
						%>
						<base:select 
							id="bioplatetype_id"
							clazz="selectionlist unchangeable"
							required="true"
							current="<%=currentBioPlateType%>"
							denied="<%=!readCurrentBioPlateType%>"
							recent="<%=recentBioPlateType%>"
							newitem="true"
						/>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Plate geometry</th>
				<td>
					<%
					if (bioplate != null)
					{
						%>
						<%=Base.getEncodedName(currentPlateGeometry, !readCurrentPlateGeometry)%>
						<%
					}
					else
					{
						%>
						<base:select 
							id="plategeometry_id"
							clazz="selectionlist unchangeable"
							required="true"
							current="<%=currentPlateGeometry%>"
							denied="<%=!readCurrentPlateGeometry%>"
							recent="<%=recentPlateGeometry%>"
							newitem="true"
						/>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Storage location</th>
				<td>
					<base:select 
						id="storage_id"
						clazz="selectionlist"
						required="false"
						data-freezer-id="<%=SystemItems.getId(Hardware.FREEZER)%>"
						data-storage-type-id="<%=currentStorageType == null ? "" : currentStorageType.getId() %>"
						current="<%=currentFreezer%>"
						denied="<%=!readCurrentFreezer%>"
						recent="<%=recentFreezers%>"
						defaultitems="<%=defaultFreezers %>"
						newitem="<%=bioplate == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">- section</th>
				<td>
					<input class="text" type="text" name="section" style="width: 10em;"
						value="<%=HTML.encodeTags(bioplate == null ? Values.getString(cc.getPropertyValue("section"), "") : bioplate.getSection())%>" 
						maxlength="<%=BioPlate.MAX_SECTION_LENGTH%>">
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">- tray</th>
				<td>
					<input class="text" type="text" name="tray" style="width: 10em;"
						value="<%=HTML.encodeTags(bioplate == null ? Values.getString(cc.getPropertyValue("tray"), "") : bioplate.getTray())%>" 
						maxlength="<%=BioPlate.MAX_TRAY_LENGTH%>">
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">- position</th>
				<td>
					<input class="text" type="text" name="position" style="width: 10em;"
						value="<%=HTML.encodeTags(bioplate == null ? Values.getString(cc.getPropertyValue("position"), "") : bioplate.getPosition())%>" 
						maxlength="<%=BioPlate.MAX_POSITION_LENGTH%>">
				</td>
				<td></td>
			</tr>	
			<tr>
				<th>Created</th>
				<td>
					<table>
					<tr>
					<td>
						<input class="text" style="width: 15em;" type="text" name="event_date" id="event_date"
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:calendar textarea="event_date" title="Created" />
					</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Barcode</th>
				<td><input class="text" type="text" name="barcode" 
					value="<%=HTML.encodeTags(bioplate == null ? Values.getString(cc.getPropertyValue("barcode"), "") : bioplate.getBarcode())%>" 
					maxlength="<%=BioPlate.MAX_BARCODE_LENGTH%>"></td>
				<td></td>
			</tr>	
			<tr>
				<th class="prompt"><label for="destroyed">Destroyed</label></th>
				<td><input type="checkbox" name="destroyed" id="destroyed" value="1"
					<%=(bioplate != null && bioplate.isDestroyed()) || (bioplate == null && Values.getBoolean(cc.getPropertyValue("destroyed"))) ? "checked" : ""%>>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(bioplate == null ? cc.getPropertyValue("description") : bioplate.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>	
		</t:tab>
		
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (bioplate == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>